var blenderApp = angular.module('blenderApp', []);

blenderApp.directive('ngFile', ['$parse', function ($parse) {
    return {
        link: function(scope, element, attrs) {
            var model = $parse(attrs.ngFile);
            var modelSetter = model.assign;
            
            element.bind('change', function(){
				scope.uploadTopic = element[0].files[0].name.split('.')[0].replace(/[-]/g, ' ');
                scope.$apply(function(){
                    modelSetter(scope, element[0].files[0]);
                });
            });
        }
    };
}]);

blenderApp.directive('clickOutside', function($document){
  return {
    restrict: 'A',
    link: function(scope, elem, attr, ctrl) {
      var elemClickHandler = function(e) {
        e.stopPropagation();
      };

      var docClickHandler = function(e) {
		if(e.target.src == undefined) {
			scope.$apply(attr.clickOutside);
		}
      };

      elem.on('click', elemClickHandler);
      $document.on('click', docClickHandler);

      // teardown the event handlers when the scope is destroyed.
      scope.$on('$destroy', function() {
        elem.off('click', elemClickHandler);
        $document.off('click', docClickHandler);
      });
    }
  }
});

blenderApp.service('fileUpload', ['$http', function ($http) {
    this.uploadFileToUrl = function(file, topic, title, user, password){
        var fd = new FormData();
        fd.append('file', file);
		fd.append('topic', topic);
		fd.append('title', title);
		fd.append('user', user);
		fd.append('password', password);
        $http.post('upload.php', fd, {
            transformRequest: angular.identity,
            headers: {'Content-Type': undefined}
        })
        .success(function(data){
			eval(data);
        })
        .error(function(data){
        });
    }
}]);

blenderApp.controller('blenderController', ['$scope', '$http', 'fileUpload', function($scope, $http, fileUpload){
	$scope.build = function (fileCount) {
		var fd = new FormData();
		fd.append('thumbsOffset', 0);
		fd.append('fileCount', fileCount);
		$http.post('build.php', fd, {
            transformRequest: angular.identity,
            headers: {'Content-Type': undefined}
        })
		
		.success(function(data){
			eval(data);
		}
		);
	}
	
    $scope.uploadFile = function(){
        fileUpload.uploadFileToUrl($scope.myIMG, $scope.uploadTopic, $scope.uploadTitle, $scope.user, $scope.password);
    };
	
	$scope.backToThumbs = function() {
		$scope.image = false;
		$scope.imagePath = '';
		$scope.uploadPrompt = false;
		$scope.thumbnails = true;
	}
	
	$scope.thumbnails = true;
	$scope.image = false;
	
	$scope.showImage = function (show, pathIndex) {
		$scope.image = show;
		$scope.thumbnails = !show;
		$scope.imagePath = blenderRenders[pathIndex][2];
		$scope.topic = blenderRenders[pathIndex][2].split('.')[1].replace(/[-]/g, ' ');
		$scope.title = blenderRenders[pathIndex][2].split('.')[2].replace(/[-]/g, ' ');
		$scope.uploadPrompt = false;
		$scope.previousIndex = blenderRenders[pathIndex][0];
		$scope.nextIndex = blenderRenders[pathIndex][1];
	}
	
	$scope.showPreviousImage = function() {
		$scope.showImage(true, $scope.previousIndex);
	}
	
	$scope.showNextImage = function() {
		$scope.showImage(true, $scope.nextIndex);
	}
	
	$scope.showUploadPrompt = function () {
		$scope.uploadPrompt = !$scope.uploadPrompt;
		$scope.image = false;
		$scope.thumbnails = !$scope.uploadPrompt;
	}
}]);