<!DOCTYPE html>

<?
include_once('variables.inc.php');
?>

<html>
<head>
    <meta http-equiv="content-type" content="text/html; charset=UTF-8">
 	<meta name="robots" content="noindex">
    <title>Blender Weekends</title>
    <link rel="stylesheet" type="text/css" href="blender.css" />
    <script src="angular.js"></script>
    <script src="gallery.js"></script>
    
    <script>
	<?
	$pattern = 'images/*.{' . implode(',', $valid_extensions) . '}';
	$files = glob($pattern, GLOB_BRACE);
	$numberOfThumbs = count($files) - $thumbsOffset >= $usualNumberOfThumbs ? $usualNumberOfThumbs : count($files) - $thumbsOffset;
	
	$thumbnailCollumns = ceil(sqrt($numberOfThumbs));
	$thumbnailRows = $thumbnailCollumns;
	
	$nextOffset = $thumbsOffset +  $numberOfThumbs < count($files) ? $thumbsOffset +  $numberOfThumbs : 0;
	$previousOffset = $thumbsOffset < $usualNumberOfThumbs ? count($files) - count($files) % $usualNumberOfThumbs : $thumbsOffset - $usualNumberOfThumbs;
	$previousOffset = $previousOffset == count($files) ? $previousOffset - $usualNumberOfThumbs : $previousOffset;
	?>
	
	var blenderRenders = [
	<? for($i = 0; $i < $numberOfThumbs; $i++) { 
		$previous_i = $i > 0 ? $i - 1 : $numberOfThumbs - 1;
		$next_i = $i < $numberOfThumbs - 1 ? $i + 1 : 0;
	?>
	[<?= $previous_i ?>, <?= $next_i ?>, '<?= $files[$i + $thumbsOffset] ?>']<? if($i < $numberOfThumbs - 1) { ?>,<? } ?>
	<? } ?>
	];
	</script>
</head>

<body ng-app="blenderApp" ng-controller="blenderController" <? if($build) { ?>ng-init="build(<?= count($files) ?>)"<? } ?>>
    <input type="button" ng-click="showUploadPrompt()" value="upload" />
	
    <div ng-show="uploadPrompt" click-outside="backToThumbs()">
    <label for="user">user</label><input type="text" ng-model="user" id="user" ng-init="user='<?= $storedUser ?>'" />
    <label for="password">password</label><input type="text" ng-model="password" id="password" ng-init="password='<?= $storedPassword ?>'" />
    <label for="uploadTopic">Topic</label><input type="text" ng-model="uploadTopic" id="uploadTopic" />
    <label for="uploadTitle">Title</label><input type="text" ng-model="uploadTitle" id="uploadTitle" />
    <input type="file" ng-file="myIMG" />
    <input type="button" ng-click="uploadFile()" value="submit" />
    </div>
     
    <section ng-show="image" click-outside="backToThumbs()">
    <h1>{{topic}}</h1>
    <div>
    <a ng-click="showPreviousImage()"><img src="previous-image.png" /></a>
    <img src="{{imagePath}}" class="blenderRender" />
    <a ng-click="showNextImage()"><img src="next-image.png" /></a>
    </div> 
    <h2>{{title}}</h2>
    </section>
    
    <section ng-show="thumbnails">
     
    <a href="./?thumbsOffset=<?= $previousOffset ?>"><img src="previous-image.png" /></a>
    
    <div class="thumbs">
    <?
	for($i = 0; $i < $thumbnailRows; $i++) {
	?>
    <div>
    <?
	for($j = 0; $j < $thumbnailCollumns; $j++) {
	if($numberOfThumbs > $i * $thumbnailCollumns + $j) {
		$file_parts = explode('.', $files[$i * $thumbnailCollumns + $j + $thumbsOffset]);
		$part_0_array = explode('/', $file_parts[0]); 
		$thumbnail = 'thumbs/thumb.' .$part_0_array[1] . '.' . $file_parts[1] . '.' . $file_parts[2] . '.' . $file_parts[3];
	?>
    <img src="<?= $thumbnail ?>" ng-click="showImage(true, '<?= $i * $thumbnailCollumns + $j ?>')" />
    <?
	}}
    ?>
    </div>
    <?
	}
    ?>
    </div>
    
    <a href="./?thumbsOffset=<?= $nextOffset ?>"><img src="next-image.png" /></a>
  
    </section>
</body>
</html>